package rexsee.core.browser.clazz;

import java.util.ArrayList;

import rexsee.core.browser.Browser;
import android.content.Context;

public class ErrorListeners {
	private final ArrayList<ErrorListener> listeners;
	public ErrorListeners() {
		listeners = new ArrayList<ErrorListener>();
	}
	public void add(ErrorListener listner) {
		listeners.add(listner);
	}
	public void clear() {
		listeners.clear();
	}
	public void run(Context context, Browser browser, int errorCode, String description, String failingUrl) {
		for (int i = 0; i < listeners.size(); i++)
			listeners.get(i).run(context, browser, errorCode, description, failingUrl);
	}
	public static abstract class ErrorListener {
		public abstract void run(Context context, Browser browser, int errorCode, String description, String failingUrl);
	}
}
