package rexsee.core.browser.clazz;

import java.util.ArrayList;

import rexsee.core.browser.Browser;
import android.content.Context;

public class LoadingProgressListeners {
	private final ArrayList<LoadingProgressListener> listeners;
	public LoadingProgressListeners() {
		listeners = new ArrayList<LoadingProgressListener>();
	}
	public void add(LoadingProgressListener listner) {
		listeners.add(listner);
	}
	public void clear() {
		listeners.clear();
	}
	public void run(Context context, Browser browser, int progress) {
		for (int i = 0; i < listeners.size(); i++)
			listeners.get(i).run(context, browser, progress);
	}
	public static abstract class LoadingProgressListener {
		public abstract void run(Context context, Browser browser, int progress);
	}
}
