package rexsee.core.browser.clazz;

import java.util.ArrayList;

import rexsee.core.browser.Browser;
import android.content.Context;
import android.graphics.Bitmap;

public class PageStartedListeners {
	private final ArrayList<PageStartedListener> listeners;
	public PageStartedListeners() {
		listeners = new ArrayList<PageStartedListener>();
	}
	public void add(PageStartedListener listner) {
		listeners.add(listner);
	}
	public void remove(PageStartedListener listner) {
		listeners.remove(listner);
	}
	public void clear() {
		listeners.clear();
	}
	public void run(Context context, Browser browser, String url, Bitmap favicon) {
		for (int i = 0; i < listeners.size(); i++)
			listeners.get(i).run(context, browser, url, favicon);
	}
	public static abstract class PageStartedListener {
		public abstract void run(Context context, Browser browser, String url, Bitmap favicon);
	}
}
