package rexsee.core.browser.clazz;

import java.util.ArrayList;

import rexsee.core.browser.Browser;
import android.content.Context;

public class ReceivedTitleListeners {
	private final ArrayList<ReceivedTitleListener> listeners;
	public ReceivedTitleListeners() {
		listeners = new ArrayList<ReceivedTitleListener>();
	}
	public void add(ReceivedTitleListener listner) {
		listeners.add(listner);
	}
	public void clear() {
		listeners.clear();
	}
	public void run(Context context, Browser browser, String title) {
		for (int i = 0; i < listeners.size(); i++)
			listeners.get(i).run(context, browser, title);
	}
	public static abstract class ReceivedTitleListener {
		public abstract void run(Context context, Browser browser, String title);
	}
}
