package rexsee.core.layout;

import rexsee.core.browser.Browser;
import rexsee.core.browser.clazz.JavascriptInterface;
import android.app.Activity;
import android.view.View;

public class RexseeStatusBar implements JavascriptInterface {

	public static final String INTERFACE_NAME = "StatusBar";
	@Override
	public String getInterfaceName() {
		return mLayout.browser.application.resources.prefix + INTERFACE_NAME;
	}
	@Override
	public JavascriptInterface getInheritInterface(Browser childBrowser) {
		return this;
	}
	@Override
	public JavascriptInterface getNewInterface(Browser childBrowser) {
		return null;
	}

	private final Activity mActivity;
	private final Layout mLayout;
	private boolean syncTag = false;

	public RexseeStatusBar(Layout layout) {
		super();
		mLayout = layout;
		mActivity = (Activity) layout.getContext();
	}

	public void setStyle(final String style) {
		syncTag = false;
		mActivity.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				mLayout.statusBar.setStyle(style);
				try {
					mLayout.statusBar.setLayoutParams(mLayout.statusBar.styleSheet.getLayoutParams());
				} catch (Exception e) {

				}
				syncTag = true;
			}
		});
		while (!syncTag) {
			try {
				Thread.sleep(20);
			} catch (Exception e) {

			}
		}
	}
	public String getStyle(String name) {
		String value = mLayout.statusBar.styleSheet.getStyle(name);
		return (value == null) ? "" : value;
	}
	public String getCurrentStyle(String name) {
		String value = mLayout.statusBar.getStyle(name);
		return (value == null) ? "" : value;
	}

	public void startAnimation(final String style) {
		mLayout.statusBar.animate(mLayout.browser, style);
	}
	public void stopAnimation() {
		mLayout.statusBar.stopAnimate();
	}

	public void setAutoHide(boolean autoHide) {
		mLayout.statusBarAutoHide = autoHide;
		if (autoHide = false) {
			String visibility = mLayout.statusBar.styleSheet.visibility.toLowerCase();
			if (visibility.equals("hidden")) {
				mLayout.statusBar.setVisibility(View.GONE);
			} else if (visibility.equals("gone")) {
				mLayout.statusBar.setVisibility(View.GONE);
			} else {
				mLayout.statusBar.setVisibility(View.VISIBLE);
			}
		}
	}
	public boolean isAutoHide() {
		return mLayout.statusBarAutoHide;
	}

}
