package rexsee.core.layout;

import rexsee.core.browser.Browser;
import rexsee.core.browser.clazz.JavascriptInterface;
import android.app.Activity;

public class RexseeTitleBar implements JavascriptInterface {

	public static final String INTERFACE_NAME = "TitleBar";
	@Override
	public String getInterfaceName() {
		return mLayout.browser.application.resources.prefix + INTERFACE_NAME;
	}
	@Override
	public JavascriptInterface getInheritInterface(Browser childBrowser) {
		return this;
	}
	@Override
	public JavascriptInterface getNewInterface(Browser childBrowser) {
		return null;
	}

	private final Activity mActivity;
	private final Layout mLayout;
	private boolean syncTag = false;

	public RexseeTitleBar(Layout layout) {
		super();
		mLayout = layout;
		mActivity = (Activity) layout.getContext();
	}

	public void setStyle(final String style) {
		syncTag = false;
		mActivity.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				mLayout.titleBar.setStyle(style);
				syncTag = true;
			}
		});
		while (!syncTag) {
			try {
				Thread.sleep(20);
			} catch (Exception e) {

			}
		}
	}
	public String getStyle(String name) {
		String value = mLayout.titleBar.styleSheet.getStyle(name);
		return (value == null) ? "" : value;
	}
	public String getCurrentStyle(String name) {
		String value = mLayout.titleBar.getStyle(name);
		return (value == null) ? "" : value;
	}

	public void startAnimation(String style) {
		mLayout.titleBar.animate(mLayout.browser, style);
	}
	public void stopAnimation() {
		mLayout.titleBar.stopAnimate();
	}

}
