package rexsee.script;

public class BlockWhile extends AbstractBlock {

	private final AbstractBlock condition;
	private final AbstractBlock body;
	public boolean breakNow = false;

	public BlockWhile(AbstractBlock parent, AbstractBlock condition, AbstractBlock body) {
		super(parent, "");
		this.condition = condition;
		this.body = body;
	}

	@Override
	public int getChildCount(int index) {
		return 0;
	}

	@Override
	public AbstractBlock getChild(int index) {
		return null;
	}

	@Override
	public Object run() {
		if (condition == null || body == null) return null;
		Object rtn = condition.run();
		boolean fail = rtn instanceof Boolean && ((Boolean) rtn) == false;
		while (!fail) {
			body.run();
			if (breakNow) break;
			rtn = condition.run();
			fail = rtn instanceof Boolean && ((Boolean) rtn) == false;
		}
		return null;
	}

}
