package rexsee.script;

import java.util.ArrayList;

public class Function extends AbstractBlock {

	private final ArrayList<AbstractBlock> childs = new ArrayList<AbstractBlock>();

	public Function(AbstractBlock parent, String script) {
		super(parent, script);
	}

	@Override
	public int getChildCount(int index) {
		return childs.size();
	}

	@Override
	public AbstractBlock getChild(int index) {
		return childs.get(index);
	}

	@Override
	public Object run() {
		Object rtn = null;
		for (int i = 0; i < childs.size(); i++) {
			rtn = childs.get(i).run();
			if (rtn != null) return rtn;
		}
		return null;
	}

}
